{smcl}
{cmd:help elabel modify}
{hline}

{title:Title}

{p 4 8 2}
{cmd:elabel modify} {hline 2} Modify value labels


{title:Syntax}

{p 8 12 2}
{cmd:elabel modify}
{it:{help elabel##elblnamelist:elblnamelist}}
{it:{help elabel##mappings:mappings}}
[ {cmd:,} {it:options} ]


{p 4 8 2}
where {it:mappings} are those used with 
{helpb elabel_define:elabel define}

{p 10 10 2}
{it:#} {cmd:"}{it:label}{cmd:"}
[ {it:#} {cmd:"}{it:label}{cmd:"} {it:...} ]

{p 8 10 2}
or

{p 10 10 2}
{cmd:(}{it:{help elabel_define##valspec:valspec}}{cmd:)}
{cmd:(}{it:{help elabel_define##lblspec:lblspec}}{cmd:)}

{p 8 10 2}
or

{p 10 10 2}
{cmd:=}
{helpb elabel_define##fcn:{it:fcn}}{opt (arguments)}


{title:Description}

{pstd}
{cmd:elabel modify} modifies value labels and, optionally, defines 
new value labels. New value labels are defined as modified copies 
of existing value labels. 


{title:Options}

{phang}
{cmdab:de:fine(}{it:{help elabel##elblnamelist:newlblnamelist}}{cmd:)} 
specifies names for the modified value labels. The mapping of old value 
label names and {it:newlblnamelist} is one to one. {it:newlblnamelist} may 
contain {help help elabel##varvaluelabel:{it:varname}{bf::}{it:lblname}}.

{phang}
{cmdab:pre:fix(}{it:str}{cmd:)} is an alternative to {cmd:define()}; the 
option prefixes old value label names with {it:str}.

{phang}
{opt replace} replaces the value labels in {it:elblnamelist} instead of 
modifying them. If {opt replace} is sepcified with {opt define()} or 
{opt prefix()}, new value labels are defined as replaced copies of 
existing value labels.

{phang}
{opt nofix} is the same as with {help label##options:label define}.


{title:Examples}

{pstd}
Load example dataset

{phang2}
{stata sysuse auto:. sysuse auto}
{p_end}

{pstd}
Define a modified copy of value label {cmd:origin}

{phang2}
{stata elabel modify origin .a "unknown" , define(origin2):. elabel modify origin .a "unknown" , define(origin2)}
{p_end}


{title:Author}

{pstd}
Daniel Klein{break}
University of Kassel{break}
klein.daniel.81@gmail.com


{title:Also see}

{psee}
Online: {help label}{p_end}

{psee}
if installed: {help elabel}
{p_end}
